"""
This type stub file was generated by pyright.
"""

from typing import TYPE_CHECKING
from . import dependency_versions_check
from .utils import CONFIG_NAME, MODEL_CARD_NAME, OptionalDependencyNotAvailable, PYTORCH_PRETRAINED_BERT_CACHE, PYTORCH_TRANSFORMERS_CACHE, SPIECE_UNDERLINE, TF2_WEIGHTS_NAME, TF_WEIGHTS_NAME, TRANSFORMERS_CACHE, TensorType, WEIGHTS_NAME, _LazyModule, add_end_docstrings, add_start_docstrings, is_apex_available, is_av_available, is_bitsandbytes_available, is_datasets_available, is_essentia_available, is_faiss_available, is_flax_available, is_g2p_en_available, is_keras_nlp_available, is_librosa_available, is_phonemizer_available, is_pretty_midi_available, is_psutil_available, is_py3nvml_available, is_pyctcdecode_available, is_sacremoses_available, is_safetensors_available, is_scipy_available, is_sentencepiece_available, is_sklearn_available, is_speech_available, is_tensorflow_text_available, is_tf_available, is_timm_available, is_tokenizers_available, is_torch_available, is_torch_hpu_available, is_torch_mlu_available, is_torch_musa_available, is_torch_neuroncore_available, is_torch_npu_available, is_torch_tpu_available, is_torch_xla_available, is_torch_xpu_available, is_torchaudio_available, is_torchvision_available, is_vision_available, logging
from .agents import Agent, CodeAgent, HfApiEngine, ManagedAgent, PipelineTool, ReactAgent, ReactCodeAgent, ReactJsonAgent, Tool, ToolCollection, Toolbox, TransformersEngine, launch_gradio_demo, load_tool, stream_to_gradio, tool
from .configuration_utils import PretrainedConfig
from .data import DataProcessor, InputExample, InputFeatures, SingleSentenceClassificationProcessor, SquadExample, SquadFeatures, SquadV1Processor, SquadV2Processor, glue_compute_metrics, glue_convert_examples_to_features, glue_output_modes, glue_processors, glue_tasks_num_labels, squad_convert_examples_to_features, xnli_compute_metrics, xnli_output_modes, xnli_processors, xnli_tasks_num_labels
from .data.data_collator import DataCollator, DataCollatorForLanguageModeling, DataCollatorForMultipleChoice, DataCollatorForPermutationLanguageModeling, DataCollatorForSOP, DataCollatorForSeq2Seq, DataCollatorForTokenClassification, DataCollatorForWholeWordMask, DataCollatorWithFlattening, DataCollatorWithPadding, DefaultDataCollator, default_data_collator
from .feature_extraction_sequence_utils import SequenceFeatureExtractor
from .feature_extraction_utils import BatchFeature, FeatureExtractionMixin
from .generation import AsyncTextIteratorStreamer, CompileConfig, GenerationConfig, TextIteratorStreamer, TextStreamer, WatermarkingConfig
from .hf_argparser import HfArgumentParser
from .integrations import is_clearml_available, is_comet_available, is_dvclive_available, is_neptune_available, is_optuna_available, is_ray_available, is_ray_tune_available, is_sigopt_available, is_swanlab_available, is_tensorboard_available, is_wandb_available
from .modelcard import ModelCard
from .modeling_tf_pytorch_utils import convert_tf_weight_name_to_pt_weight_name, load_pytorch_checkpoint_in_tf2_model, load_pytorch_model_in_tf2_model, load_pytorch_weights_in_tf2_model, load_tf2_checkpoint_in_pytorch_model, load_tf2_model_in_pytorch_model, load_tf2_weights_in_pytorch_model
from .models.albert import AlbertConfig
from .models.align import AlignConfig, AlignProcessor, AlignTextConfig, AlignVisionConfig
from .models.altclip import AltCLIPConfig, AltCLIPProcessor, AltCLIPTextConfig, AltCLIPVisionConfig
from .models.aria import AriaConfig, AriaProcessor, AriaTextConfig
from .models.audio_spectrogram_transformer import ASTConfig, ASTFeatureExtractor
from .models.auto import AutoConfig, AutoFeatureExtractor, AutoImageProcessor, AutoProcessor, AutoTokenizer, CONFIG_MAPPING, FEATURE_EXTRACTOR_MAPPING, IMAGE_PROCESSOR_MAPPING, MODEL_NAMES_MAPPING, PROCESSOR_MAPPING, TOKENIZER_MAPPING
from .models.autoformer import AutoformerConfig
from .models.aya_vision import AyaVisionConfig, AyaVisionProcessor
from .models.bamba import BambaConfig
from .models.bark import BarkCoarseConfig, BarkConfig, BarkFineConfig, BarkProcessor, BarkSemanticConfig
from .models.bart import BartConfig, BartTokenizer
from .models.beit import BeitConfig
from .models.bert import BasicTokenizer, BertConfig, BertTokenizer, WordpieceTokenizer
from .models.bert_generation import BertGenerationConfig
from .models.bert_japanese import BertJapaneseTokenizer, CharacterTokenizer, MecabTokenizer
from .models.bertweet import BertweetTokenizer
from .models.big_bird import BigBirdConfig
from .models.bigbird_pegasus import BigBirdPegasusConfig
from .models.biogpt import BioGptConfig, BioGptTokenizer
from .models.bit import BitConfig
from .models.blenderbot import BlenderbotConfig, BlenderbotTokenizer
from .models.blenderbot_small import BlenderbotSmallConfig, BlenderbotSmallTokenizer
from .models.blip import BlipConfig, BlipProcessor, BlipTextConfig, BlipVisionConfig
from .models.blip_2 import Blip2Config, Blip2Processor, Blip2QFormerConfig, Blip2VisionConfig
from .models.bloom import BloomConfig
from .models.bridgetower import BridgeTowerConfig, BridgeTowerProcessor, BridgeTowerTextConfig, BridgeTowerVisionConfig
from .models.bros import BrosConfig, BrosProcessor
from .models.byt5 import ByT5Tokenizer
from .models.camembert import CamembertConfig
from .models.canine import CanineConfig, CanineTokenizer
from .models.chameleon import ChameleonConfig, ChameleonProcessor, ChameleonVQVAEConfig
from .models.chinese_clip import ChineseCLIPConfig, ChineseCLIPProcessor, ChineseCLIPTextConfig, ChineseCLIPVisionConfig
from .models.clap import ClapAudioConfig, ClapConfig, ClapProcessor, ClapTextConfig
from .models.clip import CLIPConfig, CLIPProcessor, CLIPTextConfig, CLIPTokenizer, CLIPVisionConfig
from .models.clipseg import CLIPSegConfig, CLIPSegProcessor, CLIPSegTextConfig, CLIPSegVisionConfig
from .models.clvp import ClvpConfig, ClvpDecoderConfig, ClvpEncoderConfig, ClvpFeatureExtractor, ClvpProcessor, ClvpTokenizer
from .models.codegen import CodeGenConfig, CodeGenTokenizer
from .models.cohere import CohereConfig
from .models.cohere2 import Cohere2Config
from .models.colpali import ColPaliConfig, ColPaliProcessor
from .models.conditional_detr import ConditionalDetrConfig
from .models.convbert import ConvBertConfig, ConvBertTokenizer
from .models.convnext import ConvNextConfig
from .models.convnextv2 import ConvNextV2Config
from .models.cpmant import CpmAntConfig, CpmAntTokenizer
from .models.ctrl import CTRLConfig, CTRLTokenizer
from .models.cvt import CvtConfig
from .models.dab_detr import DabDetrConfig
from .models.dac import DacConfig, DacFeatureExtractor
from .models.data2vec import Data2VecAudioConfig, Data2VecTextConfig, Data2VecVisionConfig
from .models.dbrx import DbrxConfig
from .models.deberta import DebertaConfig, DebertaTokenizer
from .models.deberta_v2 import DebertaV2Config
from .models.decision_transformer import DecisionTransformerConfig
from .models.deformable_detr import DeformableDetrConfig
from .models.deit import DeiTConfig
from .models.deprecated.deta import DetaConfig
from .models.deprecated.efficientformer import EfficientFormerConfig
from .models.deprecated.ernie_m import ErnieMConfig
from .models.deprecated.gptsan_japanese import GPTSanJapaneseConfig, GPTSanJapaneseTokenizer
from .models.deprecated.graphormer import GraphormerConfig
from .models.deprecated.jukebox import JukeboxConfig, JukeboxPriorConfig, JukeboxTokenizer, JukeboxVQVAEConfig
from .models.deprecated.mctct import MCTCTConfig, MCTCTFeatureExtractor, MCTCTProcessor
from .models.deprecated.mega import MegaConfig
from .models.deprecated.mmbt import MMBTConfig
from .models.deprecated.nat import NatConfig
from .models.deprecated.nezha import NezhaConfig
from .models.deprecated.open_llama import OpenLlamaConfig
from .models.deprecated.qdqbert import QDQBertConfig
from .models.deprecated.realm import RealmConfig, RealmTokenizer
from .models.deprecated.retribert import RetriBertConfig, RetriBertTokenizer
from .models.deprecated.speech_to_text_2 import Speech2Text2Config, Speech2Text2Processor, Speech2Text2Tokenizer
from .models.deprecated.tapex import TapexTokenizer
from .models.deprecated.trajectory_transformer import TrajectoryTransformerConfig
from .models.deprecated.transfo_xl import TransfoXLConfig, TransfoXLCorpus, TransfoXLTokenizer
from .models.deprecated.tvlt import TvltConfig, TvltFeatureExtractor, TvltProcessor
from .models.deprecated.van import VanConfig
from .models.deprecated.vit_hybrid import ViTHybridConfig
from .models.deprecated.xlm_prophetnet import XLMProphetNetConfig
from .models.depth_anything import DepthAnythingConfig
from .models.depth_pro import DepthProConfig
from .models.detr import DetrConfig
from .models.diffllama import DiffLlamaConfig
from .models.dinat import DinatConfig
from .models.dinov2 import Dinov2Config
from .models.dinov2_with_registers import Dinov2WithRegistersConfig
from .models.distilbert import DistilBertConfig, DistilBertTokenizer
from .models.donut import DonutProcessor, DonutSwinConfig
from .models.dpr import DPRConfig, DPRContextEncoderTokenizer, DPRQuestionEncoderTokenizer, DPRReaderOutput, DPRReaderTokenizer
from .models.dpt import DPTConfig
from .models.efficientnet import EfficientNetConfig
from .models.electra import ElectraConfig, ElectraTokenizer
from .models.emu3 import Emu3Config, Emu3Processor, Emu3TextConfig, Emu3VQVAEConfig
from .models.encodec import EncodecConfig, EncodecFeatureExtractor
from .models.encoder_decoder import EncoderDecoderConfig
from .models.ernie import ErnieConfig
from .models.esm import EsmConfig, EsmTokenizer
from .models.falcon import FalconConfig
from .models.falcon_mamba import FalconMambaConfig
from .models.fastspeech2_conformer import FastSpeech2ConformerConfig, FastSpeech2ConformerHifiGanConfig, FastSpeech2ConformerTokenizer, FastSpeech2ConformerWithHifiGanConfig
from .models.flaubert import FlaubertConfig, FlaubertTokenizer
from .models.flava import FlavaConfig, FlavaImageCodebookConfig, FlavaImageConfig, FlavaMultimodalConfig, FlavaTextConfig
from .models.fnet import FNetConfig
from .models.focalnet import FocalNetConfig
from .models.fsmt import FSMTConfig, FSMTTokenizer
from .models.funnel import FunnelConfig, FunnelTokenizer
from .models.fuyu import FuyuConfig
from .models.gemma import GemmaConfig
from .models.gemma2 import Gemma2Config
from .models.gemma3 import Gemma3Config, Gemma3Processor, Gemma3TextConfig
from .models.git import GitConfig, GitProcessor, GitVisionConfig
from .models.glm import GlmConfig
from .models.glpn import GLPNConfig
from .models.got_ocr2 import GotOcr2Config, GotOcr2Processor, GotOcr2VisionConfig
from .models.gpt2 import GPT2Config, GPT2Tokenizer
from .models.gpt_bigcode import GPTBigCodeConfig
from .models.gpt_neo import GPTNeoConfig
from .models.gpt_neox import GPTNeoXConfig
from .models.gpt_neox_japanese import GPTNeoXJapaneseConfig
from .models.gptj import GPTJConfig
from .models.granite import GraniteConfig
from .models.granitemoe import GraniteMoeConfig
from .models.granitemoeshared import GraniteMoeSharedConfig
from .models.grounding_dino import GroundingDinoConfig, GroundingDinoProcessor
from .models.groupvit import GroupViTConfig, GroupViTTextConfig, GroupViTVisionConfig
from .models.helium import HeliumConfig
from .models.herbert import HerbertTokenizer
from .models.hiera import HieraConfig
from .models.hubert import HubertConfig
from .models.ibert import IBertConfig
from .models.idefics import IdeficsConfig
from .models.idefics2 import Idefics2Config
from .models.idefics3 import Idefics3Config
from .models.ijepa import IJepaConfig
from .models.imagegpt import ImageGPTConfig
from .models.informer import InformerConfig
from .models.instructblip import InstructBlipConfig, InstructBlipProcessor, InstructBlipQFormerConfig, InstructBlipVisionConfig
from .models.instructblipvideo import InstructBlipVideoConfig, InstructBlipVideoProcessor, InstructBlipVideoQFormerConfig, InstructBlipVideoVisionConfig
from .models.jamba import JambaConfig
from .models.jetmoe import JetMoeConfig
from .models.kosmos2 import Kosmos2Config, Kosmos2Processor
from .models.layoutlm import LayoutLMConfig, LayoutLMTokenizer
from .models.layoutlmv2 import LayoutLMv2Config, LayoutLMv2FeatureExtractor, LayoutLMv2ImageProcessor, LayoutLMv2Processor, LayoutLMv2Tokenizer
from .models.layoutlmv3 import LayoutLMv3Config, LayoutLMv3FeatureExtractor, LayoutLMv3ImageProcessor, LayoutLMv3Processor, LayoutLMv3Tokenizer
from .models.layoutxlm import LayoutXLMProcessor
from .models.led import LEDConfig, LEDTokenizer
from .models.levit import LevitConfig
from .models.lilt import LiltConfig
from .models.llama import LlamaConfig
from .models.llava import LlavaConfig, LlavaProcessor
from .models.llava_next import LlavaNextConfig, LlavaNextProcessor
from .models.llava_next_video import LlavaNextVideoConfig, LlavaNextVideoProcessor
from .models.llava_onevision import LlavaOnevisionConfig, LlavaOnevisionProcessor
from .models.longformer import LongformerConfig, LongformerTokenizer
from .models.longt5 import LongT5Config
from .models.luke import LukeConfig, LukeTokenizer
from .models.lxmert import LxmertConfig, LxmertTokenizer
from .models.m2m_100 import M2M100Config
from .models.mamba import MambaConfig
from .models.mamba2 import Mamba2Config
from .models.marian import MarianConfig
from .models.markuplm import MarkupLMConfig, MarkupLMFeatureExtractor, MarkupLMProcessor, MarkupLMTokenizer
from .models.mask2former import Mask2FormerConfig
from .models.maskformer import MaskFormerConfig, MaskFormerSwinConfig
from .models.mbart import MBartConfig
from .models.megatron_bert import MegatronBertConfig
from .models.mgp_str import MgpstrConfig, MgpstrProcessor, MgpstrTokenizer
from .models.mimi import MimiConfig
from .models.mistral import MistralConfig
from .models.mistral3 import Mistral3Config
from .models.mixtral import MixtralConfig
from .models.mllama import MllamaConfig, MllamaProcessor
from .models.mobilebert import MobileBertConfig, MobileBertTokenizer
from .models.mobilenet_v1 import MobileNetV1Config
from .models.mobilenet_v2 import MobileNetV2Config
from .models.mobilevit import MobileViTConfig
from .models.mobilevitv2 import MobileViTV2Config
from .models.modernbert import ModernBertConfig
from .models.moonshine import MoonshineConfig
from .models.moshi import MoshiConfig, MoshiDepthConfig
from .models.mpnet import MPNetConfig, MPNetTokenizer
from .models.mpt import MptConfig
from .models.mra import MraConfig
from .models.mt5 import MT5Config
from .models.musicgen import MusicgenConfig, MusicgenDecoderConfig
from .models.musicgen_melody import MusicgenMelodyConfig, MusicgenMelodyDecoderConfig
from .models.mvp import MvpConfig, MvpTokenizer
from .models.myt5 import MyT5Tokenizer
from .models.nemotron import NemotronConfig
from .models.nllb_moe import NllbMoeConfig
from .models.nougat import NougatProcessor
from .models.nystromformer import NystromformerConfig
from .models.olmo import OlmoConfig
from .models.olmo2 import Olmo2Config
from .models.olmoe import OlmoeConfig
from .models.omdet_turbo import OmDetTurboConfig, OmDetTurboProcessor
from .models.oneformer import OneFormerConfig, OneFormerProcessor
from .models.openai import OpenAIGPTConfig, OpenAIGPTTokenizer
from .models.opt import OPTConfig
from .models.owlv2 import Owlv2Config, Owlv2Processor, Owlv2TextConfig, Owlv2VisionConfig
from .models.owlvit import OwlViTConfig, OwlViTProcessor, OwlViTTextConfig, OwlViTVisionConfig
from .models.paligemma import PaliGemmaConfig
from .models.patchtsmixer import PatchTSMixerConfig
from .models.patchtst import PatchTSTConfig
from .models.pegasus import PegasusConfig, PegasusTokenizer
from .models.pegasus_x import PegasusXConfig
from .models.perceiver import PerceiverConfig, PerceiverTokenizer
from .models.persimmon import PersimmonConfig
from .models.phi import PhiConfig
from .models.phi3 import Phi3Config
from .models.phimoe import PhimoeConfig
from .models.phobert import PhobertTokenizer
from .models.pix2struct import Pix2StructConfig, Pix2StructProcessor, Pix2StructTextConfig, Pix2StructVisionConfig
from .models.pixtral import PixtralProcessor, PixtralVisionConfig
from .models.plbart import PLBartConfig
from .models.poolformer import PoolFormerConfig
from .models.pop2piano import Pop2PianoConfig
from .models.prompt_depth_anything import PromptDepthAnythingConfig
from .models.prophetnet import ProphetNetConfig, ProphetNetTokenizer
from .models.pvt import PvtConfig
from .models.pvt_v2 import PvtV2Config
from .models.qwen2 import Qwen2Config, Qwen2Tokenizer
from .models.qwen2_5_vl import Qwen2_5_VLConfig, Qwen2_5_VLProcessor
from .models.qwen2_audio import Qwen2AudioConfig, Qwen2AudioEncoderConfig, Qwen2AudioProcessor
from .models.qwen2_moe import Qwen2MoeConfig
from .models.qwen2_vl import Qwen2VLConfig, Qwen2VLProcessor
from .models.rag import RagConfig, RagRetriever, RagTokenizer
from .models.recurrent_gemma import RecurrentGemmaConfig
from .models.reformer import ReformerConfig
from .models.regnet import RegNetConfig
from .models.rembert import RemBertConfig
from .models.resnet import ResNetConfig
from .models.roberta import RobertaConfig, RobertaTokenizer
from .models.roberta_prelayernorm import RobertaPreLayerNormConfig
from .models.roc_bert import RoCBertConfig, RoCBertTokenizer
from .models.roformer import RoFormerConfig, RoFormerTokenizer
from .models.rt_detr import RTDetrConfig, RTDetrResNetConfig
from .models.rt_detr_v2 import RTDetrV2Config
from .models.rwkv import RwkvConfig
from .models.sam import SamConfig, SamMaskDecoderConfig, SamProcessor, SamPromptEncoderConfig, SamVisionConfig
from .models.seamless_m4t import SeamlessM4TConfig, SeamlessM4TFeatureExtractor, SeamlessM4TProcessor
from .models.seamless_m4t_v2 import SeamlessM4Tv2Config
from .models.segformer import SegformerConfig
from .models.seggpt import SegGptConfig
from .models.sew import SEWConfig
from .models.sew_d import SEWDConfig
from .models.shieldgemma2 import ShieldGemma2Config, ShieldGemma2Processor
from .models.siglip import SiglipConfig, SiglipProcessor, SiglipTextConfig, SiglipVisionConfig
from .models.siglip2 import Siglip2Config, Siglip2Processor, Siglip2TextConfig, Siglip2VisionConfig
from .models.smolvlm import SmolVLMConfig
from .models.speech_encoder_decoder import SpeechEncoderDecoderConfig
from .models.speech_to_text import Speech2TextConfig, Speech2TextFeatureExtractor, Speech2TextProcessor
from .models.speecht5 import SpeechT5Config, SpeechT5FeatureExtractor, SpeechT5HifiGanConfig, SpeechT5Processor
from .models.splinter import SplinterConfig, SplinterTokenizer
from .models.squeezebert import SqueezeBertConfig, SqueezeBertTokenizer
from .models.stablelm import StableLmConfig
from .models.starcoder2 import Starcoder2Config
from .models.superglue import SuperGlueConfig
from .models.superpoint import SuperPointConfig
from .models.swiftformer import SwiftFormerConfig
from .models.swin import SwinConfig
from .models.swin2sr import Swin2SRConfig
from .models.swinv2 import Swinv2Config
from .models.switch_transformers import SwitchTransformersConfig
from .models.t5 import T5Config
from .models.table_transformer import TableTransformerConfig
from .models.tapas import TapasConfig, TapasTokenizer
from .models.textnet import TextNetConfig
from .models.time_series_transformer import TimeSeriesTransformerConfig
from .models.timesformer import TimesformerConfig
from .models.timm_backbone import TimmBackboneConfig
from .models.timm_wrapper import TimmWrapperConfig
from .models.trocr import TrOCRConfig, TrOCRProcessor
from .models.tvp import TvpConfig, TvpProcessor
from .models.udop import UdopConfig, UdopProcessor
from .models.umt5 import UMT5Config
from .models.unispeech import UniSpeechConfig
from .models.unispeech_sat import UniSpeechSatConfig
from .models.univnet import UnivNetConfig, UnivNetFeatureExtractor
from .models.upernet import UperNetConfig
from .models.video_llava import VideoLlavaConfig
from .models.videomae import VideoMAEConfig
from .models.vilt import ViltConfig, ViltFeatureExtractor, ViltImageProcessor, ViltProcessor
from .models.vipllava import VipLlavaConfig
from .models.vision_encoder_decoder import VisionEncoderDecoderConfig
from .models.vision_text_dual_encoder import VisionTextDualEncoderConfig, VisionTextDualEncoderProcessor
from .models.visual_bert import VisualBertConfig
from .models.vit import ViTConfig
from .models.vit_mae import ViTMAEConfig
from .models.vit_msn import ViTMSNConfig
from .models.vitdet import VitDetConfig
from .models.vitmatte import VitMatteConfig
from .models.vitpose import VitPoseConfig
from .models.vitpose_backbone import VitPoseBackboneConfig
from .models.vits import VitsConfig, VitsTokenizer
from .models.vivit import VivitConfig
from .models.wav2vec2 import Wav2Vec2CTCTokenizer, Wav2Vec2Config, Wav2Vec2FeatureExtractor, Wav2Vec2Processor, Wav2Vec2Tokenizer
from .models.wav2vec2_bert import Wav2Vec2BertConfig, Wav2Vec2BertProcessor
from .models.wav2vec2_conformer import Wav2Vec2ConformerConfig
from .models.wav2vec2_phoneme import Wav2Vec2PhonemeCTCTokenizer
from .models.wav2vec2_with_lm import Wav2Vec2ProcessorWithLM
from .models.wavlm import WavLMConfig
from .models.whisper import WhisperConfig, WhisperFeatureExtractor, WhisperProcessor, WhisperTokenizer
from .models.x_clip import XCLIPConfig, XCLIPProcessor, XCLIPTextConfig, XCLIPVisionConfig
from .models.xglm import XGLMConfig
from .models.xlm import XLMConfig, XLMTokenizer
from .models.xlm_roberta import XLMRobertaConfig
from .models.xlm_roberta_xl import XLMRobertaXLConfig
from .models.xlnet import XLNetConfig
from .models.xmod import XmodConfig
from .models.yolos import YolosConfig
from .models.yoso import YosoConfig
from .models.zamba import ZambaConfig
from .models.zamba2 import Zamba2Config
from .models.zoedepth import ZoeDepthConfig
from .pipelines import AudioClassificationPipeline, AutomaticSpeechRecognitionPipeline, CsvPipelineDataFormat, DepthEstimationPipeline, DocumentQuestionAnsweringPipeline, FeatureExtractionPipeline, FillMaskPipeline, ImageClassificationPipeline, ImageFeatureExtractionPipeline, ImageSegmentationPipeline, ImageTextToTextPipeline, ImageToImagePipeline, ImageToTextPipeline, JsonPipelineDataFormat, MaskGenerationPipeline, NerPipeline, ObjectDetectionPipeline, PipedPipelineDataFormat, Pipeline, PipelineDataFormat, QuestionAnsweringPipeline, SummarizationPipeline, TableQuestionAnsweringPipeline, Text2TextGenerationPipeline, TextClassificationPipeline, TextGenerationPipeline, TextToAudioPipeline, TokenClassificationPipeline, TranslationPipeline, VideoClassificationPipeline, VisualQuestionAnsweringPipeline, ZeroShotAudioClassificationPipeline, ZeroShotClassificationPipeline, ZeroShotImageClassificationPipeline, ZeroShotObjectDetectionPipeline, pipeline
from .processing_utils import ProcessorMixin
from .tokenization_utils import PreTrainedTokenizer
from .tokenization_utils_base import AddedToken, BatchEncoding, CharSpan, PreTrainedTokenizerBase, SpecialTokensMixin, TokenSpan
from .trainer_callback import DefaultFlowCallback, EarlyStoppingCallback, PrinterCallback, ProgressCallback, TrainerCallback, TrainerControl, TrainerState
from .trainer_utils import EvalPrediction, IntervalStrategy, SchedulerType, enable_full_determinism, set_seed
from .training_args import TrainingArguments
from .training_args_seq2seq import Seq2SeqTrainingArguments
from .training_args_tf import TFTrainingArguments
from .utils.quantization_config import AqlmConfig, AwqConfig, BitNetConfig, BitsAndBytesConfig, CompressedTensorsConfig, EetqConfig, FbgemmFp8Config, FineGrainedFP8Config, GPTQConfig, HiggsConfig, HqqConfig, QuantoConfig, QuarkConfig, SpQRConfig, TorchAoConfig, VptqConfig

__version__ = ...
logger = ...
_import_structure = ...
if not is_sentencepiece_available():
    ...
if not is_tokenizers_available():
    ...
if not (is_sentencepiece_available() and is_tokenizers_available()):
    ...
if not is_tensorflow_text_available():
    ...
if not is_keras_nlp_available():
    ...
if not is_vision_available():
    ...
if not is_torchvision_available():
    ...
if not (is_torchvision_available() and is_timm_available()):
    ...
if not is_torch_available():
    ...
if not is_tf_available():
    ...
if not (is_librosa_available() and is_essentia_available() and is_scipy_available() and is_torch_available() and is_pretty_midi_available()):
    ...
if not is_torchaudio_available():
    ...
if not is_flax_available():
    ...
if TYPE_CHECKING:
    ...
else:
    ...
if not is_tf_available() and not is_torch_available() and not is_flax_available():
    ...
